// Solution to problem B of eindwedstrijd Voorbereiding
// Programmeerwedstrijden: Bracket Sequence

#include <iostream>
#include <cstring>
#include <cstdio>
using namespace std;
const int maxtokenlength = 10;
const long long modnumber = 1000000007;

long long readsum (int n, int &i);

//*************************************************************************

// read product, just after having read an opening bracket
long long readproduct (int n, int &i)
{ long long product;
  char token[maxtokenlength+1];
  long long tokennumber;  // number represented by token

  product = 1;

  while (i<n)
  { cin >> token;
    i++;
    if (token[0] == '(')
    { product  = (product * readsum (n, i)) % modnumber;
//      cout << "product=" << product << endl;
    }
    else
      if (token[0] == ')')
        return product;
      else
      { sscanf (token, "%lld", &tokennumber);
        product = (product * tokennumber) % modnumber;
//        cout << "product=" << product << endl;
      }
  }  // while

  return product;  // not necessary, just for security and to avoid
                   // compiler warnings
  
}  // readproduct

//*************************************************************************

// read sum, just after having read an opening bracket or just started
long long readsum (int n, int &i)
{ long long sum;
  char token[maxtokenlength+1];
  long long tokennumber;  // number represented by token

  sum = 0;

  while (i<n)  // only necessary if this is the outermost sum
  { cin >> token;
    i++;
    if (token[0] == '(')
    { sum = (sum + readproduct (n, i)) % modnumber;
//      cout << "sum=" << sum << endl;
    }
    else
      if (token[0] == ')')
        return sum;
      else
      { sscanf (token, "%lld", &tokennumber);
        sum = (sum + tokennumber) % modnumber;
//        cout << "sum=" << sum << endl;
      }
  }  // while

  return sum;  // only necessary if this is the outermost sum
  
}  // readsum

//*************************************************************************

int main ()
{ int n; 
  int i;

  cin >> n;  // number of tokens
  i = 0;

  cout << readsum (n, i) << endl;

  return 0;
}
